define( function() {
"use strict";

function C_HtmlSelect()
{
};

C_HtmlSelect.prototype.draw = function( oControlHost )
{   
    this.m_oControlHost = oControlHost;
    var oParameter = oControlHost.getParameter( "pl" );  

	var aParameterValues = ( oParameter && ( oParameter.values.length > 0 ) ) ? oParameter.values.map(function(o) { return o.use; }) : "";
	var sHtml = '<select size="5" style="font-size:12pt;" multiple="true">';
    var iRowCount = this.m_oDataStore.rowCount;
    
	for ( var iRow = 0; iRow < iRowCount; iRow++ )
	{
		var sValue = this.m_oDataStore.getCellValue( iRow, 0 );
		var bSelected = !!aParameterValues && ( aParameterValues.indexOf(sValue) != -1 );
		sHtml += '<option ' + ( bSelected ? ' selected="true"' : '' ) + '>' + sValue + '</option>';
    }
    
	sHtml += '</select>';
	var el = oControlHost.container;
	el.innerHTML = sHtml;
	this.m_sel = el.querySelector( "*" );
	this.f_onChange( oControlHost );
    this.m_sel.onchange = this.f_onChange.bind( this, oControlHost, true );
    el.onclick = this.f_onChange.bind( this, oControlHost, true );
};

C_HtmlSelect.prototype.f_onChange = function( oControlHost, bAutoSubmit )
{
	oControlHost.valueChanged();
};

C_HtmlSelect.prototype.setData = function( oControlHost, oDataStore )
{
	this.m_oDataStore = oDataStore;
};

C_HtmlSelect.prototype.getParameters = function()
{
	
	var v_aValues = [];
	var nl = this.m_oControlHost.container.querySelectorAll( "option" );
	for ( var i = 0; i < nl.length; i++ )
	{
		var el = nl.item( i );
		if ( el.selected )
		{
			v_aValues.push( { "use" : el.value } );
		}
	}
	return [{
		"parameter": "pl",
		"values": v_aValues
	}];
};


C_HtmlSelect.prototype.isInValidState = function()
{
	return true;
};
return C_HtmlSelect;
});
